---
title: AesCtrParams
slug: Web/API/AesCtrParams
tags:
  - API
  - AesCtrParams
  - Dictionary
  - Reference
  - Web Crypto API
---
<div>{{ APIRef("Web Crypto API") }}</div>

<p>The <strong><code>AesCtrParams</code></strong> dictionary of the <a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API </a>represents the object that should be passed as the <code>algorithm</code> parameter into {{domxref("SubtleCrypto.encrypt()")}}, {{domxref("SubtleCrypto.decrypt()")}}, {{domxref("SubtleCrypto.wrapKey()")}}, or {{domxref("SubtleCrypto.unwrapKey()")}}, when using the <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#AES-CTR">AES-CTR</a> algorithm.</p>

<p>AES is a block cipher, meaning that it splits the message into blocks and encrypts it a block at a time. In CTR mode, every time a block of the message is encrypted, an extra block of data is mixed in. This extra block is called the "counter block".</p>

<p>A given counter block value must never be used more than once with the same key:</p>

<ul>
 <li>Given a message <em>n</em> blocks long, a different counter block must be used for every block.</li>
 <li>If the same key is used to encrypt more than one message, a different counter block must be used for all blocks across all messages.</li>
</ul>

<p>Typically this is achieved by splitting the initial counter block value into two concatenated parts:</p>

<ul>
 <li>A <a href="https://en.wikipedia.org/wiki/Cryptographic_nonce">nonce</a> (that is, a number that may only be used once). The nonce part of the block stays the same for every block in the message. Each time a new message is to be encrypted, a new nonce is chosen. Nonces don't have to be secret, but they must not be reused with the same key.</li>
 <li>A counter. This part of the block gets incremented each time a block is encrypted.</li>
</ul>

<p>Essentially: the nonce should ensure that counter blocks are not reused from one message to the next, while the counter should ensure that counter blocks are not reused within a single message.</p>

<div class="notecard note">
<p><strong>Note</strong>: See <a href="https://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38a.pdf#%5B%7B%22num%22%3A70%2C%22gen%22%3A0%7D%2C%7B%22name%22%3A%22Fit%22%7D%5D">Appendix B of the NIST SP800-38A standard</a> for more information.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>name</code></dt>
 <dd>A {{domxref("DOMString")}}. This should be set to <code>AES-CTR</code>.</dd>
 <dt><code>counter</code></dt>
 <dd>A {{domxref("BufferSource")}} — the initial value of the counter block. This must be 16 bytes long (the AES block size). The rightmost <code>length</code> bits of this block are used for the counter, and the rest is used for the nonce. For example, if <code>length</code> is set to 64, then the first half of <code>counter</code> is the nonce and the second half is used for the counter.</dd>
 <dt><code>length</code></dt>
 <dd>A <code>Number</code> — the number of bits in the counter block that are used for the actual counter. The counter must be big enough that it doesn't wrap: if the message is <code>n</code> blocks and the counter is <code>m</code> bits long, then the following must be true: <code>n &lt;= 2<sup>m</sup></code>. The <a class="external external-icon" href="https://csrc.nist.gov/publications/detail/sp/800-38a/final" rel="noopener">NIST SP800-38A</a> standard, which defines CTR, suggests that the counter should occupy half of the counter block (see <a href="https://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38a.pdf#%5B%7B%22num%22%3A73%2C%22gen%22%3A0%7D%2C%7B%22name%22%3A%22Fit%22%7D%5D">Appendix B.2</a>), so for AES it would be 64.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>See the examples for {{domxref("SubtleCrypto.encrypt()")}} and {{domxref("SubtleCrypto.decrypt()")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Web Crypto API', '#dfn-AesCtrParams', 'SubtleCrypto.AesCtrParams') }}</td>
   <td>{{ Spec2('Web Crypto API') }}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>Browsers that support the "AES-CTR" algorithm for the {{domxref("SubtleCrypto.encrypt()")}}, {{domxref("SubtleCrypto.decrypt()")}}, {{domxref("SubtleCrypto.wrapKey()")}}, or {{domxref("SubtleCrypto.unwrapKey()")}} methods will support this type.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>CTR mode is defined in section 6.5 of the <a class="external external-icon" href="https://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38a.pdf#%5B%7B%22num%22%3A70%2C%22gen%22%3A0%7D%2C%7B%22name%22%3A%22Fit%22%7D%5D" rel="noopener">NIST SP800-38A standard</a>.</li>
 <li>{{domxref("SubtleCrypto.encrypt()")}}.</li>
 <li>{{domxref("SubtleCrypto.decrypt()")}}.</li>
 <li>{{domxref("SubtleCrypto.wrapKey()")}}.</li>
 <li>{{domxref("SubtleCrypto.unwrapKey()")}}.</li>
</ul>
